
Orchestrator - Bug #51311

Failed to apply ingress.rgw: IndexError: list index out of range

06/22/2021 10:09 AM - Sigurd Brinch

Status: Resolved % Done: 0%

Priority: High   

Assignee: Sebastian Wagner   

Category: cephadm   

Target version:    

Source:  Affected Versions: v16.2.4

Tags:  ceph-qa-suite:  

Backport:  Pull request ID: 42433

Regression: No Crash signature (v1):  

Severity: 3 - minor Crash signature (v2):  

Reviewed:    

Description

Following the docs at: https://docs.ceph.com/en/latest/cephadm/rgw/ I've set up rgw with:

# ceph orch apply rgw ikt --placement="3" 

 

Then to add the ingress I used:

# ceph orch apply -i rgw-ingress.yaml

 

where rgw-ingress.yaml containes:

service_type: ingress

service_id: rgw.ikt

placement:

  count: 3

spec:

  backend_service: rgw.ikt

  virtual_ip: 192.168.20.63/24

  frontend_port: 9000

  monitor_port: 1967

  ssl_cert: |

    -----BEGIN CERTIFICATE-----

    blabla

    -----END CERTIFICATE-----

    -----BEGIN PRIVATE KEY-----

    blabla

    -----END PRIVATE KEY-----

 

This gives the output:

Scheduled ingress.rgw.ikt update...

But in the MGR log it gives:

debug 2021-06-22T10:04:50.073+0000 7f30ebd57700  0 log_channel(cephadm) log [INF] : Saving service
 ingress.rgw.ikt spec with placement count:3

debug 2021-06-22T10:04:50.129+0000 7f31ce804700  0 log_channel(cephadm) log [INF] : 192.16.20.63 i

s 192.16.20.0/24 on bamboo-grm5 interface bond0

debug 2021-06-22T10:04:50.133+0000 7f31ce804700  0 [cephadm ERROR cephadm.serve] Failed to apply i

ngress.rgw.ikt spec IngressSpec({'placement': PlacementSpec(count=3), 'service_type': 'ingress', '

service_id': 'rgw.ikt', 'unmanaged': False, 'preview_only': False, 'networks': [], 'config': None,

 'backend_service': 'rgw.ikt', 'frontend_port': 9000, 'ssl_cert': None, 'ssl_dh_param': None, 'ssl

_ciphers': None, 'ssl_options': None, 'monitor_port': 1967, 'monitor_user': None, 'monitor_passwor

d': None, 'keepalived_password': None, 'virtual_ip': '192.16.20.63/24', 'virtual_interface_network

s': [], 'haproxy_container_image': None, 'keepalived_container_image': None}): list index out of r

ange

Traceback (most recent call last):

  File "/usr/share/ceph/mgr/cephadm/serve.py", line 466, in _apply_all_services

    if self._apply_service(spec):

  File "/usr/share/ceph/mgr/cephadm/serve.py", line 625, in _apply_service

    daemon_spec = svc.prepare_create(daemon_spec)

  File "/usr/share/ceph/mgr/cephadm/services/ingress.py", line 31, in prepare_create

    return self.keepalived_prepare_create(daemon_spec)

  File "/usr/share/ceph/mgr/cephadm/services/ingress.py", line 127, in keepalived_prepare_create

    daemon_spec.final_config, daemon_spec.deps = self.keepalived_generate_config(daemon_spec)

  File "/usr/share/ceph/mgr/cephadm/services/ingress.py", line 192, in keepalived_generate_config

    if hosts[0] == host:

IndexError: list index out of range

debug 2021-06-22T10:04:50.133+0000 7f31ce804700 -1 log_channel(cephadm) log [ERR] : Failed to appl

y ingress.rgw.ikt spec IngressSpec({'placement': PlacementSpec(count=3), 'service_type': 'ingress'

, 'service_id': 'rgw.ikt', 'unmanaged': False, 'preview_only': False, 'networks': [], 'config': No

ne, 'backend_service': 'rgw.ikt', 'frontend_port': 9000, 'ssl_cert': None, 'ssl_dh_param': None, '

ssl_ciphers': None, 'ssl_options': None, 'monitor_port': 1967, 'monitor_user': None, 'monitor_pass

word': None, 'keepalived_password': None, 'virtual_ip': '192.16.20.63/24', 'virtual_interface_netw

orks': [], 'haproxy_container_image': None, 'keepalived_container_image': None}): list index out o

f range

Traceback (most recent call last):

  File "/usr/share/ceph/mgr/cephadm/serve.py", line 466, in _apply_all_services

    if self._apply_service(spec):

  File "/usr/share/ceph/mgr/cephadm/serve.py", line 625, in _apply_service

    daemon_spec = svc.prepare_create(daemon_spec)

  File "/usr/share/ceph/mgr/cephadm/services/ingress.py", line 31, in prepare_create

    return self.keepalived_prepare_create(daemon_spec)

  File "/usr/share/ceph/mgr/cephadm/services/ingress.py", line 127, in keepalived_prepare_create

    daemon_spec.final_config, daemon_spec.deps = self.keepalived_generate_config(daemon_spec)

  File "/usr/share/ceph/mgr/cephadm/services/ingress.py", line 192, in keepalived_generate_config

    if hosts[0] == host:

IndexError: list index out of range

Related issues:

Duplicated by Orchestrator - Bug #51713: Cephadm: Timeout waiting for ingress... Duplicate

History

#1 - 06/22/2021 10:12 AM - Sebastian Wagner

- Description updated

- Priority changed from Normal to High

#2 - 06/22/2021 10:13 AM - Sebastian Wagner

- Subject changed from MGR log reports "IndexError: list index out of range" when trying to apply an rgw ingress to pacific 16.2.4 to Failed to apply

ingress.rgw: IndexError: list index out of range

#3 - 06/22/2021 10:29 AM - Sigurd Brinch

- File ceph_orch_ps.yaml added

#4 - 07/18/2021 09:21 AM - Asbjørn Sannes

What does
ceph orch ls

give you?    

I had that error when I put the wrong backend service name there (or they were not currently running).

I did have it complaining loudly on setting up those missing haproxies with something like:

log_channel(cephadm) log [ERR] : Failed while placing haproxy.rgw.test.test-1.host1.kcwssk on host1: ingress.r

gw.test.test-1 backend service rgw.test.test-1 does not exist

in the logs.    

It could probably behave a bit better with:

diff --git a/src/pybind/mgr/cephadm/services/ingress.py b/src/pybind/mgr/cephadm/services/ingress.py

index f78f558a2d8..34a69d3dede 100644

--- a/src/pybind/mgr/cephadm/services/ingress.py

+++ b/src/pybind/mgr/cephadm/services/ingress.py

@@ -187,6 +187,9 @@ class IngressService(CephService):

         host = daemon_spec.host

         hosts = sorted(list(set([str(d.hostname) for d in daemons])))

+        if len(hosts) == 0:

+            raise OrchestratorError(

+                f"Unable to find any haproxy daemons for service {spec.service_name()}, not starting keepaliv

ed.")

#5 - 07/21/2021 08:15 AM - Sebastian Wagner

- Duplicated by Bug #51713: Cephadm: Timeout waiting for ingress.nfs.foo to start added

#6 - 07/21/2021 08:50 AM - Sebastian Wagner
- Status changed from New to Fix Under Review

- Assignee set to Sebastian Wagner

- Pull request ID set to 42433

#7 - 07/21/2021 11:46 AM - Sigurd Brinch

1. ceph orch ls

NAME                       PORTS  RUNNING  REFRESHED  AGE  PLACEMENT

alertmanager                          1/1  6m ago     8w   count:1

crash                               12/12  6m ago     8w   *

grafana                               1/1  6m ago     8w   count:1

mds.csi-cephfs                        2/2  6m ago     8w   count:2

mgr                                   2/2  6m ago     8w   count:2

mon                                   5/5  6m ago     8w   count:5

node-exporter                       12/12  6m ago     8w   *

osd.all-available-devices           85/97  6m ago     8w   *

prometheus                            1/1  6m ago     8w   count:1

rgw.ikt                    ?:80       3/3  6m ago     4w   count:3

#8 - 08/20/2021 12:25 PM - Sebastian Wagner

- Status changed from Fix Under Review to Resolved

Files

ceph_orch_ps.yaml 45.3 KB 06/22/2021 Sigurd Brinch

Powered by TCPDF (www.tcpdf.org)

03/13/2024 4/4

http://www.tcpdf.org

